Qwt User's Guide: QwtWidgetOverlay Class Reference

Qwt User's Guide 6.1.5

Public Types | Public Member Functions | Protected Member Functions | List of all members
QwtWidgetOverlay Class Referenceabstract

An overlay for a widget. More...

`#include <qwt_widget_overlay.h>`

Inheritance diagram for QwtWidgetOverlay:
[legend]

## Public Types
enum | MaskMode { NoMask, MaskHint, AlphaMask }
| Mask mode. More...
enum | RenderMode { AutoRenderMode, CopyAlphaMask, DrawOverlay }
| Render mode. More...

## Public Member Functions
| QwtWidgetOverlay (QWidget *)
| Constructor. More...
virtual | ~QwtWidgetOverlay ()
| Destructor.
void | setMaskMode (MaskMode)
| Specify how to find the mask for the overlay. More...
MaskMode | maskMode () const
void | setRenderMode (RenderMode)
RenderMode | renderMode () const
void | updateOverlay ()
virtual bool | eventFilter (QObject *, QEvent *)
| Event filter. More...

## Protected Member Functions
virtual void | paintEvent (QPaintEvent *event)
virtual void | resizeEvent (QResizeEvent *event)
virtual QRegion | maskHint () const
| Calculate an approximation for the mask. More...
virtual void | drawOverlay (QPainter *painter) const =0

## Detailed Description

An overlay for a widget.

The main use case of an widget overlay is to avoid heavy repaint operation of the widget below.

F.e. in combination with the plot canvas an overlay avoid replots as the content of the canvas can be restored from its backing store.

QwtWidgetOverlay is an abstract base class. Deriving classes are supposed to reimplement the following methods:

- drawOverlay()
- maskHint()

Internally QwtPlotPicker uses overlays for displaying the rubber band and the tracker text.

See also
  QwtPlotCanvas::BackingStore

## Member Enumeration Documentation

## ◆ MaskMode

enum QwtWidgetOverlay::MaskMode

Mask mode.

When using masks the widget below gets paint events for the masked regions of the overlay only. Otherwise Qt triggers full repaints. On less powerful hardware ( f.e embedded systems ) - or when using the raster paint engine on a remote desktop - bit blitting is a noticeable operation, that needs to be avoided.

If and how to mask depends on how expensive the calculation of the mask is and how many pixels can be excluded by the mask.

The default setting is MaskHint.

See also
  setMaskMode(), maskMode()

Enumerator
NoMask | Don't use a mask.
MaskHint | Use maskHint() as mask. For many situations a fast approximation is good enough and it is not necessary to build a more detailed mask ( f.e the bounding rectangle of a text ).
AlphaMask | Calculate a mask by checking the alpha values. Sometimes it is not possible to give a fast approximation and the mask needs to be calculated by drawing the overlay and testing the result. When a valid maskHint() is available only pixels inside this approximation are checked.

## ◆ RenderMode

enum QwtWidgetOverlay::RenderMode

Render mode.

For calculating the alpha mask the overlay has already been painted to a temporary QImage. Instead of rendering the overlay twice this buffer can be copied for drawing the overlay.

On graphic systems using the raster paint engine ( QWS, Windows ) it means usually copying some memory only. On X11 it results in an expensive operation building a pixmap and for simple overlays it might not be recommended.

Note
  The render mode has no effect, when maskMode() != AlphaMask.

Enumerator
AutoRenderMode | Copy the buffer, when using the raster paint engine.
CopyAlphaMask | Always copy the buffer.
DrawOverlay | Never copy the buffer.

## Constructor & Destructor Documentation

## ◆ QwtWidgetOverlay()

QwtWidgetOverlay::QwtWidgetOverlay | ( | QWidget * | widget | ) |

Constructor.

Parameters

  widget | Parent widget, where the overlay is aligned to

## Member Function Documentation

## ◆ drawOverlay()

virtual void QwtWidgetOverlay::drawOverlay | ( | QPainter * | painter | ) | const
| protectedpure virtual

Draw the widget overlay

Parameters

  painter | Painter

## ◆ eventFilter()

bool QwtWidgetOverlay::eventFilter | ( | QObject * | object,
|  | QEvent * | event
| ) |  |
| virtual

Event filter.

Resize the overlay according to the size of the parent widget.

Parameters

  object | Object to be filtered
  event | Event

Returns
  See QObject::eventFilter()

## ◆ maskHint()

QRegion QwtWidgetOverlay::maskHint | ( |  | ) | const
| protectedvirtual

Calculate an approximation for the mask.

- MaskHint The hint is used as mask.
- AlphaMask The hint is used to speed up the algorithm for calculating a mask from non transparent pixels
- NoMask The hint is unused.

The default implementation returns an invalid region indicating no hint.

Returns
  Hint for the mask

## ◆ maskMode()

QwtWidgetOverlay::MaskMode QwtWidgetOverlay::maskMode | ( |  | ) | const

Returns
  Mode how to find the mask for the overlay

See also
  setMaskMode()

## ◆ paintEvent()

void QwtWidgetOverlay::paintEvent | ( | QPaintEvent * | event | ) |
| protectedvirtual

Paint event

Parameters

  event | Paint event

See also
  drawOverlay()

## ◆ renderMode()

QwtWidgetOverlay::RenderMode QwtWidgetOverlay::renderMode | ( |  | ) | const

Returns
  Render mode

See also
  RenderMode, setRenderMode()

## ◆ resizeEvent()

void QwtWidgetOverlay::resizeEvent | ( | QResizeEvent * | event | ) |
| protectedvirtual

Resize event

Parameters

  event | Resize event

## ◆ setMaskMode()

void QwtWidgetOverlay::setMaskMode | ( | MaskMode | mode | ) |

Specify how to find the mask for the overlay.

Parameters

  mode | New mode

See also
  maskMode()

## ◆ setRenderMode()

void QwtWidgetOverlay::setRenderMode | ( | RenderMode | mode | ) |

Set the render mode

Parameters

  mode | Render mode

See also
  RenderMode, renderMode()

## ◆ updateOverlay()

void QwtWidgetOverlay::updateOverlay | ( |  | ) |

Recalculate the mask and repaint the overlay